#!/bin/sh
#
# Starts dropbear sshd.
#

# Make sure the dropbearkey progam exists
[ -f /usr/bin/dropbearkey ] || exit 0

start() {
	#do not start server if ssh disabled flag exists
	if [ -f /ross/etc/sshServerDisabled ] ; then
		echo "SSH Server disabled. Exiting"
		exit 0
	fi
	
 	echo -n "Starting dropbear sshd: "
	# Make sure dropbear directory exists
	if [ ! -d /etc/dropbear ] ; then
		mkdir -p /etc/dropbear
	fi
	# Check for the Dropbear RSA key
	if [ ! -f /etc/dropbear/dropbear_rsa_host_key ] ; then
		echo -n "generating rsa key... "
		/usr/bin/dropbearkey -t rsa -f /etc/dropbear/dropbear_rsa_host_key > /dev/null 2>&1
	fi

	# Check for the Dropbear ECDSA key
	if [ ! -f /etc/dropbear/dropbear_ecdsa_host_key ] ; then
		echo -n "generating ecdsa key... "
		/usr/bin/dropbearkey -t ecdsa -f /etc/dropbear/dropbear_ecdsa_host_key > /dev/null 2>&1
	fi

	# Check for the Dropbear ED25519 key
	if [ ! -f /etc/dropbear/dropbear_ed25519_host_key ] ; then
		echo -n "generating ed25519 key... "
		/usr/bin/dropbearkey -t ed25519 -f /etc/dropbear/dropbear_ed25519_host_key > /dev/null 2>&1
	fi

	umask 077
	start-stop-daemon -S -q -p /var/run/dropbear.pid --exec /usr/sbin/dropbear -- -R
	[ $? = 0 ] && echo "OK" || echo "FAIL"
}
stop() {
	echo -n "Stopping dropbear sshd: "
	start-stop-daemon -K --retry 15 --oknodo -q -p /var/run/dropbear.pid
	[ $? = 0 ] && echo "OK" || echo "FAIL"
}
restart() {
	stop
	start
}

case "$1" in
  start)
  	start
	;;
  stop)
  	stop
	;;
  restart|reload)
  	restart
	;;
  *)
	echo "Usage: $0 {start|stop|restart}"
	exit 1
esac

exit $?


